// db_mssql.cpp : Defines the entry point for the DLL application.
//

#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers
#include <windows.h>
#include <stdio.h>
#include "db_mssql.h"

#import "C:\Program Files\Common Files\System\ADO\msado15.dll" no_namespace rename("EOF","adoEOF")

_ConnectionPtr g_pConnection;

BOOL Init()
{
	if (OleInitialize(NULL) == S_OK) {
		return SUCCEEDED(g_pConnection.CreateInstance("ADODB.Connection"));
	}
	return FALSE;
}

void Fini()
{
	db_disconnect();
	OleUninitialize(); //β
}

/* get the hex string presentation of a binary
    dst     :   hex string
    data    :   binary data
    size    :   size of data
    !!make sure dst's size >= size*2+1
*/
char* ToHexString(char* dst, const unsigned char* data, size_t size)
{
	char pBuf[4];
    size_t i;

    if (!dst) return NULL;

	memset( dst, 0, sizeof( char ) * (size * 2 + 1) );
	for(i=0; i<size; i++ )
	{
		memset( pBuf, 0, sizeof( char ) * 4 );
		sprintf( pBuf, "%02x", (unsigned char)data[i] );
		strcat(dst, pBuf);
	}
	return dst;
}


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
	case DLL_PROCESS_ATTACH:
		Init();
		break;
	case DLL_THREAD_ATTACH:
		break;
	case DLL_THREAD_DETACH:
		break;
	case DLL_PROCESS_DETACH:
		Fini();
		break;
	}
    return TRUE;
}

DB_MSSQL_API BOOL CALL_TYPE db_connect(LPSTR conn_str)
{

	try
	{
		{
			if (SUCCEEDED(g_pConnection->Open(conn_str, "", "", adConnectUnspecified)))
			{	
				//MessageBox(NULL, "Connection Ok", "conn result", MB_OKCANCEL);
				return TRUE;
			}
		}
	}
	catch (_com_error e)
	{
		//MessageBox(NULL, e.ErrorMessage(), "conn error", MB_OKCANCEL);
		return FALSE;
	} 
	catch (...)
	{
	}
	return FALSE;


}

DB_MSSQL_API BOOL CALL_TYPE db_update(const unsigned char* info_hash, int completed_num, int peer_num, int seeder_num)
{
	char sql[256];
	char temp[32];

	
	if ((info_hash == NULL) || (completed_num < 0) || (peer_num < 0) || (seeder_num < 0) )
	{
		return FALSE;
	}
	
	strcpy(sql, "EXEC xfyang.bcs_update 0x");
    ToHexString(temp, info_hash, 20);	
	strcat(sql, temp); 
	strcat(sql, ", '");
	strcat(sql, temp); 
	strcat(sql, "', ");
    itoa(completed_num, temp, 10);
	strcat(sql, temp); 
	strcat(sql, ", ");
	itoa(peer_num, temp, 10);
	strcat(sql, temp); 
	strcat(sql, ", ");
	itoa(seeder_num, temp, 10);
	strcat(sql, temp); 

	try {
		g_pConnection->Execute(_bstr_t(sql), NULL, adExecuteNoRecords);
		return TRUE;
	}catch(_com_error e) {
		return FALSE;
	}
	return FALSE;
}

DB_MSSQL_API BOOL CALL_TYPE db_disconnect()
{
	try
	{
		if (g_pConnection != NULL && g_pConnection->State == adStateOpen) 
		{
			if (SUCCEEDED(g_pConnection->Close()))
			{
				return TRUE;
			}
		}
	}
	catch(_com_error e)
	{
		return FALSE;
	} 
	return FALSE;
}


DB_MSSQL_API int CALL_TYPE db_fetch(info_list_t** head)
{
	_RecordsetPtr	pRecordset;
	char sql[256];
	_variant_t value;
	info_list_t* p;
	int n = 0;

	*head = NULL;

#if (0)
	int i;
	*head = NULL;
	for (i = 0; i < 100; i++) {
		p = (info_list_t*)malloc(sizeof(info_list_t));
		if (i % 2 == 0) {
			strncpy(p->info, "1234567890123456789012345678901234567890", 40);			
		}
		else {
			strncpy(p->info, "0987654321098765432109876543210987654321", 40);			
		}
		p->next = *head;
		*head = p;
		n++;
	}
	return n;
#endif	
	
	//strcpy(sql, "select ST_Hash from SubmitTable");
	strcpy(sql, "select localTF from metatable where localTF!='Ǳ'");
	
	try	{
		pRecordset.CreateInstance("ADODB.Recordset");
		
		pRecordset->Open(
			_bstr_t(sql), 
			_variant_t((IDispatch*)g_pConnection, true),
			adOpenStatic, 
			adLockOptimistic, 
			adCmdText);

			
		if (pRecordset == NULL) 
			return -1;
		
		n = 0;
		*head = NULL;
		//if (pRecordset->BOF)
			//pRecordset->MoveFirst(); //Ƶݿⶥ
		while (!(pRecordset->adoEOF)) {
			//value = pRecordset->GetCollect(_variant_t("localTF"));
			value = pRecordset->GetCollect(_variant_t(long(0)));
			switch (value.vt)	{
			case VT_BSTR:
			case VT_LPSTR:
			case VT_LPWSTR:
				strcpy(sql, (char*)(_bstr_t)value);
				break;
			default:
				return -1;
			}
			
			if (strlen(sql) == 40) {
				p = (info_list_t*)malloc(sizeof(info_list_t));
				strncpy(p->info, sql, 40);
				p->next = *head;
				*head = p;
				n++;
			}
			
			pRecordset->MoveNext();
		}
		
		return n;
			
	}catch (_com_error e) {
		return -1;
	}
	return -1;
}


DB_MSSQL_API int CALL_TYPE db_fetch2(info_list_t** head)
{
	return db_fetch(head);
}
